/**
 * CQRCode
 * @author Tevin
 */

<template>
    <view class="c-qr-code">
        <canvas ref="canvas"></canvas>
    </view>
</template>

<script>
import Taro from '@tarojs/taro';
import { $ } from '@tarojs/extend';
import QRCode from 'qrcode';
import './cQrCode.scss';

export default {
    name: 'CQRCode',
    components: {},
    props: {
        content: {
            type: String,
            default: 'http://www.aisim.cn',
        },
        size: {
            type: Number,
            default: 200,
        },
        margin: {
            type: Number,
            default: 2,
        },
    },
    data() {
        return {};
    },
    methods: {
        _renderQRCode(canvasDom) {
            QRCode.toCanvas(
                canvasDom,
                this.content,
                {
                    width: this.size,
                    margin: this.margin,
                },
                err => {
                    if (err) {
                        console.error(err);
                        return;
                    }
                }
            );
        },
    },
    mounted() {
        if (process.env.TARO_ENV === 'h5') {
            const canvasBox = $(this.$refs.canvas.$el);
            const finderTimer = setInterval(() => {
                const canvasDom = canvasBox.find('canvas');
                if (canvasDom.length > 0) {
                    this._renderQRCode(canvasDom[0]);
                }
            }, 10);
        } else {
            // TODO: 小程序中获取canvas
        }
    },
};
</script>